package me.totalfreedom.discord.util;

import discord4j.common.util.Snowflake;
import discord4j.core.object.entity.Guild;
import discord4j.core.object.entity.Member;
import discord4j.core.object.entity.Role;
import me.totalfreedom.discord.Bot;
import me.totalfreedom.totalfreedommod.TotalFreedomMod;
import me.totalfreedom.totalfreedommod.admin.Admin;
import me.totalfreedom.totalfreedommod.config.ConfigEntry;
import me.totalfreedom.totalfreedommod.player.PlayerData;
import me.totalfreedom.totalfreedommod.rank.Rank;
import me.totalfreedom.totalfreedommod.rank.Title;
import me.totalfreedom.totalfreedommod.util.FLog;
import org.bukkit.Bukkit;

public class TFM_Bridge
{
    private final Bot bot;
    private final TotalFreedomMod commons;

    public TFM_Bridge(Bot bot)
    {
        this.bot = bot;
        this.commons = (TotalFreedomMod) Bukkit.getPluginManager().getPlugin("TotalFreedomMod");

        if (commons == null) throw new IllegalStateException();
    }

    public String getDisplay(Member member)
    {
        Guild server = bot.getGuildById().block();
        // Server Owner
        assert server != null;
        return member.getRoles().map(role ->
        {
            if (role.getId().equals(SnowflakeEntry.OWNER_ROLE_ID.getSnowflake()))
            {
                return Title.OWNER.getColoredTag();
            }
            else if (role.getId().equals(SnowflakeEntry.DEVELOPER_ROLE_ID.getSnowflake()))
            {
                return Title.DEVELOPER.getColoredTag();
            }
            else if (role.getId().equals(SnowflakeEntry.EXECUTIVE_ROLE_ID.getSnowflake()))
            {
                return Title.EXECUTIVE.getColoredTag();
            }
            else if (role.getId().equals(SnowflakeEntry.ASSISTANT_EXECUTIVE_ROLE_ID.getSnowflake()))
            {
                return Title.ASSTEXEC.getColoredTag();
            }
            else if (role.getId().equals(SnowflakeEntry.SENIOR_ADMIN_ROLE_ID.getSnowflake()))
            {
                return Rank.SENIOR_ADMIN.getColoredTag();
            }
            else if (role.getId().equals(SnowflakeEntry.ADMIN_ROLE_ID.getSnowflake()))
            {
                return Rank.ADMIN.getColoredTag();
            }
            else if (role.getId().equals(SnowflakeEntry.MASTERBUILDER_ROLE_ID.getSnowflake()))
            {
                return Title.MASTER_BUILDER.getColoredTag();
            }
            else
            {
                return "";
            }
        }).blockFirst();
    }

    public TotalFreedomMod getCommons()
    {
        return commons;
    }
}
