package me.totalfreedom.shop;

import me.totalfreedom.totalfreedommod.TotalFreedomMod;
import me.totalfreedom.totalfreedommod.api.Context;
import me.totalfreedom.totalfreedommod.api.ShoppeCommons;
import org.bukkit.plugin.java.JavaPlugin;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TFShoppe extends JavaPlugin
{
    private final Logger slf4j = LoggerFactory.getLogger("TF-Shoppe");
    private Shop shop;
    private Votifier votifier;

    public Logger slf4j()
    {
        return slf4j;
    }

    @Override
    public void onEnable()
    {
        slf4j().info("Hello from the TF-Shoppe! Attempting to resolve TotalFreedomMod...");

        TotalFreedomMod plugin = (TotalFreedomMod) getServer().getPluginManager().getPlugin("TotalFreedomMod");
        if (plugin == null)
        {
            slf4j().error("TotalFreedomMod not found! Disabling...");
            getServer().getPluginManager().disablePlugin(this);
            return;
        }

        slf4j().info("TotalFreedomMod found! Registering the shop...");
        shop = new Shop();

        slf4j().info("Shop registered! Registering the Votifier listener...");
        votifier = new Votifier();

        slf4j().info("Votifier listener registered! Providing context to TFM...");
        Context<ShoppeCommons> context = new Context<>(shop);
        plugin.ag.setShoppeContext(context);
        plugin.registerShoppe();

        slf4j().info("Context provided! TF-Shoppe is now ready to go!");
    }

    @Override
    public void onDisable()
    {
        slf4j().info("Goodbye from the TF-Shoppe!");
    }
}
